diff -Naur tomato/release/src/router/pppd/pppd/utils.c tomato121/release/src/router/pppd/pppd/utils.c
--- tomato/release/src/router/pppd/pppd/utils.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/utils.c	2008-04-22 21:44:05.000000000 +1000
@@ -1,23 +1,34 @@
 /*
  * utils.c - various utility functions used in pppd.
  *
- * Copyright (c) 1999 The Australian National University.
- * All rights reserved.
+ * Copyright (c) 1999-2002 Paul Mackerras. All rights reserved.
  *
- * Redistribution and use in source and binary forms are permitted
- * provided that the above copyright notice and this paragraph are
- * duplicated in all such forms and that any documentation,
- * advertising materials, and other materials related to such
- * distribution and use acknowledge that the software was developed
- * by the Australian National University.  The name of the University
- * may not be used to endorse or promote products derived from this
- * software without specific prior written permission.
- * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
- * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. The name(s) of the authors of this software must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission.
+ *
+ * 3. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Paul Mackerras
+ *     <paulus@samba.org>".
+ *
+ * THE AUTHORS OF THIS SOFTWARE DISCLAIM ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
+ * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
 
-#define RCSID	"$Id: utils.c,v 1.6 2004/09/23 06:40:55 tallest Exp $"
+#define RCSID	"$Id: utils.c,v 1.24 2004/11/04 10:02:26 paulus Exp $"
 
 #include <stdio.h>
 #include <ctype.h>
@@ -29,6 +40,7 @@
 #include <fcntl.h>
 #include <syslog.h>
 #include <netdb.h>
+#include <time.h>
 #include <utmp.h>
 #include <pwd.h>
 #include <sys/param.h>
@@ -44,8 +56,8 @@
 #endif
 
 #include "pppd.h"
-
-#include <sys/sysinfo.h>
+#include "fsm.h"
+#include "lcp.h"
 
 static const char rcsid[] = RCSID;
 
@@ -106,7 +118,7 @@
 /*
  * slprintf - format a message into a buffer.  Like sprintf except we
  * also specify the length of the output buffer, and we handle
- * %r (recursive format), %m (error message), %v (visible string),
+ * %m (error message), %v (visible string),
  * %q (quoted string), %t (current time) and %I (IP address) formats.
  * Doesn't do floating-point formats.
  * Returns the number of chars put into buf.
@@ -208,6 +220,28 @@
 	neg = 0;
 	++fmt;
 	switch (c) {
+	case 'l':
+	    c = *fmt++;
+	    switch (c) {
+	    case 'd':
+		val = va_arg(args, long);
+		if (val < 0) {
+		    neg = 1;
+		    val = -val;
+		}
+		base = 10;
+		break;
+	    case 'u':
+		val = va_arg(args, unsigned long);
+		base = 10;
+		break;
+	    default:
+		*buf++ = '%'; --buflen;
+		*buf++ = 'l'; --buflen;
+		--fmt;		/* so %lz outputs %lz etc. */
+		continue;
+	    }
+	    break;
 	case 'd':
 	    i = va_arg(args, int);
 	    if (i < 0) {
@@ -253,6 +287,7 @@
 		     (ip >> 16) & 0xff, (ip >> 8) & 0xff, ip & 0xff);
 	    str = num;
 	    break;
+#if 0	/* not used, and breaks on S/390, apparently */
 	case 'r':
 	    f = va_arg(args, char *);
 #ifndef __powerpc__
@@ -264,6 +299,7 @@
 	    buf += n;
 	    buflen -= n;
 	    continue;
+#endif
 	case 't':
 	    time(&t);
 	    str = ctime(&t);
@@ -644,6 +680,7 @@
 /*
  * fatal - log an error message and die horribly.
  */
+/*
 void
 fatal __V((char *fmt, ...))
 {
@@ -660,12 +697,9 @@
     logit(LOG_ERR, fmt, pvar);
     va_end(pvar);
 
-    die(1);			/* as promised */
+    die(1);			
 }
 
-/*
- * error - log an error message.
- */
 void
 error __V((char *fmt, ...))
 {
@@ -681,11 +715,9 @@
 
     logit(LOG_ERR, fmt, pvar);
     va_end(pvar);
+    ++error_count;
 }
 
-/*
- * warn - log a warning message.
- */
 void
 warn __V((char *fmt, ...))
 {
@@ -702,10 +734,8 @@
     logit(LOG_WARNING, fmt, pvar);
     va_end(pvar);
 }
-
+*/
 /*
- * notice - log a notice-level message.
- */
 void
 notice __V((char *fmt, ...))
 {
@@ -722,11 +752,8 @@
     logit(LOG_NOTICE, fmt, pvar);
     va_end(pvar);
 }
-
-/*
- * info - log an informational message.
- */
-void
+*/
+/*void
 info __V((char *fmt, ...))
 {
     va_list pvar;
@@ -742,10 +769,8 @@
     logit(LOG_INFO, fmt, pvar);
     va_end(pvar);
 }
-
+*/
 /*
- * dbglog - log a debug message.
- */
 void
 dbglog __V((char *fmt, ...))
 {
@@ -762,10 +787,66 @@
     logit(LOG_DEBUG, fmt, pvar);
     va_end(pvar);
 }
+*/
+/*
+ * dump_packet - print out a packet in readable form if it is interesting.
+ * Assumes len >= PPP_HDRLEN.
+ */
+void
+dump_packet(const char *tag, unsigned char *p, int len)
+{
+    int proto;
+
+    if (!debug)
+	return;
+
+    /*
+     * don't print LCP echo request/reply packets if debug <= 1
+     * and the link is up.
+     */
+    proto = (p[2] << 8) + p[3];
+    if (debug <= 1 && unsuccess == 0 && proto == PPP_LCP
+	&& len >= PPP_HDRLEN + HEADERLEN) {
+	unsigned char *lcp = p + PPP_HDRLEN;
+	int l = (lcp[2] << 8) + lcp[3];
+
+	if ((lcp[0] == ECHOREQ || lcp[0] == ECHOREP)
+	    && l >= HEADERLEN && l <= len - PPP_HDRLEN)
+	    return;
+    }
+
+    dbglog("%s %P", tag, p, len);
+}
+
+/*
+ * complete_read - read a full `count' bytes from fd,
+ * unless end-of-file or an error other than EINTR is encountered.
+ */
+ssize_t
+complete_read(int fd, void *buf, size_t count)
+{
+	size_t done;
+	ssize_t nb;
+	char *ptr = buf;
+
+	for (done = 0; done < count; ) {
+		nb = read(fd, ptr, count - done);
+		if (nb < 0) {
+			if (errno == EINTR)
+				continue;
+			return -1;
+		}
+		if (nb == 0)
+			break;
+		done += nb;
+		ptr += nb;
+	}
+	return done;
+}
 
 /* Procedures for locking the serial device using a lock file. */
 #ifndef LOCK_DIR
-#ifdef _linux_
+#ifdef __linux__
 #define LOCK_DIR	"/var/lock"
 #else
 #ifdef SVR4
@@ -790,7 +871,7 @@
 
     result = mklock (dev, (void *) 0);
     if (result == 0) {
-	strlcpy(lock_file, sizeof(lock_file), dev);
+	strlcpy(lock_file, dev, sizeof(lock_file));
 	return 0;
     }
 
@@ -821,9 +902,20 @@
 	     major(sbuf.st_rdev), minor(sbuf.st_rdev));
 #else
     char *p;
+    char lockdev[MAXPATHLEN];
+
+    if ((p = strstr(dev, "dev/")) != NULL) {
+	dev = p + 4;
+	strncpy(lockdev, dev, MAXPATHLEN-1);
+	lockdev[MAXPATHLEN-1] = 0;
+	while ((p = strrchr(lockdev, '/')) != NULL) {
+	    *p = '_';
+	}
+	dev = lockdev;
+    } else
+	if ((p = strrchr(dev, '/')) != NULL)
+	    dev = p + 1;
 
-    if ((p = strrchr(dev, '/')) != NULL)
-	dev = p + 1;
     slprintf(lock_file, sizeof(lock_file), "%s/LCK..%s", LOCK_DIR, dev);
 #endif
 
@@ -948,46 +1040,3 @@
     }
 }
 
-//===================================================
-#include <fcntl.h>
-#define GOT_IP                  0x01
-#define RELEASE_IP              0x02
-#define GET_IP_ERROR            0x03
-#define RELEASE_WAN_CONTROL     0x04
-#define SET_LED(val) \
-{ \
-        int filep; \
-        if ((filep = open("/dev/extio", O_RDWR,0))) \
-        { \
-                ioctl(filep, val, 0); \
-                close(filep); \
-        } \
-}
-//==================================================
-
-int
-log_to_file(char *buf)	// add by honor
-{	
-	FILE *fp;
-	
-	if ((fp = fopen("/tmp/ppp/log", "w"))) {
-		fprintf(fp, "%s", buf);
-		fclose(fp);
-		SET_LED(GET_IP_ERROR)
-		return 1;
-	}	
-	return 0;
-}
-
-int
-my_gettimeofday(struct timeval *timenow, struct timezone *tz)
-{
-	struct sysinfo info;
-
-        sysinfo(&info);
-
-	timenow->tv_sec = info.uptime;
-	timenow->tv_usec = 0;
-
-	return 0;
-}
diff -Naur tomato/release/src/router/pppd/pppdump/bsd-comp.c tomato121/release/src/router/pppd/pppdump/bsd-comp.c
--- tomato/release/src/router/pppd/pppdump/bsd-comp.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/bsd-comp.c	2008-04-22 21:44:05.000000000 +1000
@@ -38,12 +38,14 @@
  */
 
 /*
- * $Id: bsd-comp.c,v 1.1 2003/07/10 07:43:05 honor Exp $
+ * $Id: bsd-comp.c,v 1.4 2004/01/17 05:47:55 carlsonj Exp $
  */
 
 #include <sys/types.h>
+#include <stdio.h>
 #include <stddef.h>
 #include <stdlib.h>
+#include <string.h>
 #include "ppp_defs.h"
 #include "ppp-comp.h"
 
diff -Naur tomato/release/src/router/pppd/pppdump/deflate.c tomato121/release/src/router/pppd/pppdump/deflate.c
--- tomato/release/src/router/pppd/pppdump/deflate.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/deflate.c	2008-04-22 21:44:05.000000000 +1000
@@ -2,35 +2,45 @@
  * ppp_deflate.c - interface the zlib procedures for Deflate compression
  * and decompression (as used by gzip) to the PPP code.
  *
- * Copyright (c) 1994 The Australian National University.
- * All rights reserved.
+ * Copyright (c) 1994 Paul Mackerras. All rights reserved.
  *
- * Permission to use, copy, modify, and distribute this software and its
- * documentation is hereby granted, provided that the above copyright
- * notice appears in all copies.  This software is provided without any
- * warranty, express or implied. The Australian National University
- * makes no representations about the suitability of this software for
- * any purpose.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
  *
- * IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY BE LIABLE TO ANY
- * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
- * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
- * THE AUSTRALIAN NATIONAL UNIVERSITY HAS BEEN ADVISED OF THE POSSIBILITY
- * OF SUCH DAMAGE.
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
  *
- * THE AUSTRALIAN NATIONAL UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES,
- * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
- * ON AN "AS IS" BASIS, AND THE AUSTRALIAN NATIONAL UNIVERSITY HAS NO
- * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
- * OR MODIFICATIONS.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
  *
- * $Id: deflate.c,v 1.1 2003/07/10 07:43:05 honor Exp $
+ * 3. The name(s) of the authors of this software must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission.
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Paul Mackerras
+ *     <paulus@samba.org>".
+ *
+ * THE AUTHORS OF THIS SOFTWARE DISCLAIM ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
+ * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * $Id: deflate.c,v 1.5 2004/01/17 05:47:55 carlsonj Exp $
  */
 
 #include <sys/types.h>
+#include <stdio.h>
 #include <stddef.h>
 #include <stdlib.h>
+#include <string.h>
 #include "ppp_defs.h"
 #include "ppp-comp.h"
 #include "zlib.h"
diff -Naur tomato/release/src/router/pppd/pppdump/Makefile tomato121/release/src/router/pppd/pppdump/Makefile
--- tomato/release/src/router/pppd/pppdump/Makefile	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/Makefile	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,22 @@
+DESTDIR = $(INSTROOT)@DESTDIR@
+BINDIR = $(DESTDIR)/sbin
+MANDIR = $(DESTDIR)/share/man/man8
+
+COPTS = -O
+CFLAGS= $(COPTS) -I../include/net
+OBJS = pppdump.o bsd-comp.o deflate.o zlib.o
+
+INSTALL= install
+
+all:	pppdump
+
+pppdump: $(OBJS)
+	$(CC) -o pppdump $(OBJS)
+
+clean:
+	rm -f pppdump $(OBJS) *~
+
+install:
+	mkdir -p $(BINDIR) $(MANDIR)
+	$(INSTALL) -c pppdump $(BINDIR)
+	$(INSTALL) -c -m 444 pppdump.8 $(MANDIR)
diff -Naur tomato/release/src/router/pppd/pppdump/Makefile.linux tomato121/release/src/router/pppd/pppdump/Makefile.linux
--- tomato/release/src/router/pppd/pppdump/Makefile.linux	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/Makefile.linux	2008-04-22 21:44:05.000000000 +1000
@@ -1,4 +1,9 @@
-CFLAGS= -O -I../include/net
+DESTDIR = $(INSTROOT)@DESTDIR@
+BINDIR = $(DESTDIR)/sbin
+MANDIR = $(DESTDIR)/share/man/man8
+
+COPTS = -O
+CFLAGS= $(COPTS) -I../include/net
 OBJS = pppdump.o bsd-comp.o deflate.o zlib.o
 
 INSTALL= install
@@ -12,6 +17,6 @@
 	rm -f pppdump $(OBJS) *~
 
 install:
-	mkdir -p $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -c pppdump $(BINDIR)
-	$(INSTALL) -c -m 444 pppdump.8 $(MANDIR)/man8
+	mkdir -p $(BINDIR) $(MANDIR)
+	$(INSTALL) -c pppdump $(BINDIR)
+	$(INSTALL) -c -m 444 pppdump.8 $(MANDIR)
diff -Naur tomato/release/src/router/pppd/pppdump/Makefile.sol2 tomato121/release/src/router/pppd/pppdump/Makefile.sol2
--- tomato/release/src/router/pppd/pppdump/Makefile.sol2	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/Makefile.sol2	2008-04-22 21:44:05.000000000 +1000
@@ -1,9 +1,9 @@
 #
 # pppdump Makefile for SVR4 systems
-# $Id: Makefile.sol2,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.sol2,v 1.4 2002/09/07 05:15:25 carlsonj Exp $
 #
 
-include ../solaris/Makedefs
+include ../Makedefs.com
 
 CFLAGS= $(COPTS) -I../include/net
 OBJS = pppdump.o bsd-comp.o deflate.o zlib.o
diff -Naur tomato/release/src/router/pppd/pppdump/ppp-comp.h tomato121/release/src/router/pppd/pppdump/ppp-comp.h
--- tomato/release/src/router/pppd/pppdump/ppp-comp.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/ppp-comp.h	2008-04-22 21:44:05.000000000 +1000
@@ -1,30 +1,38 @@
 /*
  * ppp-comp.h - Definitions for doing PPP packet compression.
  *
- * Copyright (c) 1994 The Australian National University.
- * All rights reserved.
+ * Copyright (c) 1994 Paul Mackerras. All rights reserved.
  *
- * Permission to use, copy, modify, and distribute this software and its
- * documentation is hereby granted, provided that the above copyright
- * notice appears in all copies.  This software is provided without any
- * warranty, express or implied. The Australian National University
- * makes no representations about the suitability of this software for
- * any purpose.
- *
- * IN NO EVENT SHALL THE AUSTRALIAN NATIONAL UNIVERSITY BE LIABLE TO ANY
- * PARTY FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
- * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
- * THE AUSTRALIAN NATIONAL UNIVERSITY HAVE BEEN ADVISED OF THE POSSIBILITY
- * OF SUCH DAMAGE.
- *
- * THE AUSTRALIAN NATIONAL UNIVERSITY SPECIFICALLY DISCLAIMS ANY WARRANTIES,
- * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
- * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
- * ON AN "AS IS" BASIS, AND THE AUSTRALIAN NATIONAL UNIVERSITY HAS NO
- * OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS,
- * OR MODIFICATIONS.
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
  *
- * $Id: ppp-comp.h,v 1.1 2003/07/10 07:43:05 honor Exp $
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ *
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in
+ *    the documentation and/or other materials provided with the
+ *    distribution.
+ *
+ * 3. The name(s) of the authors of this software must not be used to
+ *    endorse or promote products derived from this software without
+ *    prior written permission.
+ *
+ * 4. Redistributions of any form whatsoever must retain the following
+ *    acknowledgment:
+ *    "This product includes software developed by Paul Mackerras
+ *     <paulus@samba.org>".
+ *
+ * THE AUTHORS OF THIS SOFTWARE DISCLAIM ALL WARRANTIES WITH REGARD TO
+ * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS, IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
+ * SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
+ * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ *
+ * $Id: ppp-comp.h,v 1.2 2002/12/06 09:49:16 paulus Exp $
  */
 
 #ifndef _NET_PPP_COMP_H
diff -Naur tomato/release/src/router/pppd/pppdump/zlib.c tomato121/release/src/router/pppd/pppdump/zlib.c
--- tomato/release/src/router/pppd/pppdump/zlib.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/zlib.c	2008-04-22 21:44:05.000000000 +1000
@@ -11,7 +11,7 @@
  * - added Z_PACKET_FLUSH (see zlib.h for details)
  * - added inflateIncomp
  *
- * $Id: zlib.c,v 1.1 2003/07/10 07:43:05 honor Exp $
+ * $Id: zlib.c,v 1.2 1999/04/01 07:26:30 paulus Exp $
  */
 
 
diff -Naur tomato/release/src/router/pppd/pppdump/zlib.h tomato121/release/src/router/pppd/pppdump/zlib.h
--- tomato/release/src/router/pppd/pppdump/zlib.h	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppdump/zlib.h	2008-04-22 21:44:05.000000000 +1000
@@ -1,4 +1,4 @@
-/*	$Id: zlib.h,v 1.1 2003/07/10 07:43:05 honor Exp $	*/
+/*	$Id: zlib.h,v 1.1 1999/03/23 03:21:58 paulus Exp $	*/
 
 /*
  * This file is derived from zlib.h and zconf.h from the zlib-0.95
diff -Naur tomato/release/src/router/pppd/pppstats/Makefile tomato121/release/src/router/pppd/pppstats/Makefile
--- tomato/release/src/router/pppd/pppstats/Makefile	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppstats/Makefile	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,36 @@
+#
+# pppstats makefile
+# $Id: Makefile.linux,v 1.9 2006/06/04 05:07:46 paulus Exp $
+#
+DESTDIR = $(INSTROOT)@DESTDIR@
+BINDIR = $(DESTDIR)/sbin
+MANDIR = $(DESTDIR)/share/man/man8
+
+PPPSTATSRCS = pppstats.c
+PPPSTATOBJS = pppstats.o
+
+#CC = gcc
+COPTS = -O
+COMPILE_FLAGS = -I../include
+LIBS =
+
+INSTALL= install
+
+CFLAGS = $(COPTS) $(COMPILE_FLAGS)
+
+all: pppstats
+
+install: pppstats
+	-mkdir -p $(MANDIR)
+	$(INSTALL) -c pppstats $(BINDIR)
+	$(INSTALL) -c -m 444 pppstats.8 $(MANDIR)
+
+pppstats: $(PPPSTATSRCS)
+	$(CC) $(CFLAGS) -o pppstats pppstats.c $(LIBS)
+
+clean:
+	rm -f pppstats *~ #* core
+
+depend:
+	cpp -M $(CFLAGS) $(PPPSTATSRCS) >.depend
+#	makedepend $(CFLAGS) $(PPPSTATSRCS)
diff -Naur tomato/release/src/router/pppd/pppstats/Makefile.linux tomato121/release/src/router/pppd/pppstats/Makefile.linux
--- tomato/release/src/router/pppd/pppstats/Makefile.linux	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppstats/Makefile.linux	2008-04-22 21:44:05.000000000 +1000
@@ -1,25 +1,29 @@
 #
 # pppstats makefile
-# $Id: Makefile.linux,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.linux,v 1.9 2006/06/04 05:07:46 paulus Exp $
 #
+DESTDIR = $(INSTROOT)@DESTDIR@
+BINDIR = $(DESTDIR)/sbin
+MANDIR = $(DESTDIR)/share/man/man8
 
 PPPSTATSRCS = pppstats.c
 PPPSTATOBJS = pppstats.o
 
 #CC = gcc
 COPTS = -O
-COMPILE_FLAGS = -D_linux_ -I../include
+COMPILE_FLAGS = -I../include
 LIBS =
 
-INSTALL= install -o root -g daemon
+INSTALL= install
 
 CFLAGS = $(COPTS) $(COMPILE_FLAGS)
 
 all: pppstats
 
 install: pppstats
-	$(INSTALL) -s -c pppstats $(BINDIR)/pppstats
-	$(INSTALL) -c -m 444 pppstats.8 $(MANDIR)/man8/pppstats.8
+	-mkdir -p $(MANDIR)
+	$(INSTALL) -c pppstats $(BINDIR)
+	$(INSTALL) -c -m 444 pppstats.8 $(MANDIR)
 
 pppstats: $(PPPSTATSRCS)
 	$(CC) $(CFLAGS) -o pppstats pppstats.c $(LIBS)
diff -Naur tomato/release/src/router/pppd/pppstats/Makefile.sol2 tomato121/release/src/router/pppd/pppstats/Makefile.sol2
--- tomato/release/src/router/pppd/pppstats/Makefile.sol2	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppstats/Makefile.sol2	2008-04-22 21:44:05.000000000 +1000
@@ -1,9 +1,9 @@
 #
 # pppstats Makefile for SVR4 systems
-# $Id: Makefile.sol2,v 1.1 2003/07/10 07:43:05 honor Exp $
+# $Id: Makefile.sol2,v 1.10 2002/09/07 05:15:25 carlsonj Exp $
 #
 
-include ../solaris/Makedefs
+include ../Makedefs.com
 
 CFLAGS = -DSTREAMS -I../include $(COPTS)
 
diff -Naur tomato/release/src/router/pppd/pppstats/pppstats.c tomato121/release/src/router/pppd/pppstats/pppstats.c
--- tomato/release/src/router/pppd/pppstats/pppstats.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppstats/pppstats.c	2008-04-22 21:44:05.000000000 +1000
@@ -36,7 +36,7 @@
 #endif
 
 #ifndef lint
-static const char rcsid[] = "$Id: pppstats.c,v 1.1 2003/07/10 07:43:05 honor Exp $";
+static const char rcsid[] = "$Id: pppstats.c,v 1.29 2002/10/27 12:56:26 fcusack Exp $";
 #endif
 
 #include <stdio.h>
@@ -53,13 +53,13 @@
 #include <sys/ioctl.h>
 
 #ifndef STREAMS
-#if defined(_linux_) && defined(__powerpc__) \
+#if defined(__linux__) && defined(__powerpc__) \
     && (__GLIBC__ == 2 && __GLIBC_MINOR__ == 0)
 /* kludge alert! */
 #undef __GLIBC__
 #endif
 #include <sys/socket.h>		/* *BSD, Linux, NeXT, Ultrix etc. */
-#ifndef _linux_
+#ifndef __linux__
 #include <net/if.h>
 #include <net/ppp_defs.h>
 #include <net/if_ppp.h>
@@ -74,7 +74,7 @@
 #endif
 #include <linux/ppp_defs.h>
 #include <linux/if_ppp.h>
-#endif /* _linux_ */
+#endif /* __linux__ */
 
 #else	/* STREAMS */
 #include <sys/stropts.h>	/* SVR4, Solaris 2, SunOS 4, OSF/1, etc. */
@@ -144,7 +144,7 @@
 
     memset (&req, 0, sizeof (req));
 
-#ifdef _linux_
+#ifdef __linux__
     req.stats_ptr = (caddr_t) &req.stats;
 #undef ifr_name
 #define ifr_name ifr__name
@@ -170,7 +170,7 @@
 
     memset (&creq, 0, sizeof (creq));
 
-#ifdef _linux_
+#ifdef __linux__
     creq.stats_ptr = (caddr_t) &creq.stats;
 #undef  ifr_name
 #define ifr_name ifr__name
@@ -190,7 +190,7 @@
 	}
     }
 
-#ifdef _linux_
+#ifdef __linux__
     if (creq.stats.c.bytes_out == 0) {
 	creq.stats.c.bytes_out = creq.stats.c.comp_bytes + creq.stats.c.inc_bytes;
 	creq.stats.c.in_count = creq.stats.c.unc_bytes;
@@ -522,7 +522,7 @@
 	    exit(1);
 	}
 
-#ifdef _linux_
+#ifdef __linux__
 #undef  ifr_name
 #define ifr_name ifr_ifrn.ifrn_name
 #endif
